#ifndef _GRN_LOG_H_
#define _GRN_LOG_H_

#include <string>
#include <iostream>


#define GRN_ENABLE_LOG


#ifdef GIRONA_PSP
extern "C" 
{
	extern void __psp_log (const char *fmt, ...);
}
#endif


namespace grn
{
	
#ifdef GRN_ENABLE_LOG

	#ifndef GIRONA_PSP
		inline void log( const std::string& s ) { std::cout<<s<<std::endl; }
		inline void log( const std::string& s, int i ) { std::cout<<s<<i<<std::endl; }
		inline void log( const std::string& s, const std::string& s2 ) { std::cout<<s<<s2<<std::endl; }
		inline void log( const std::string& s, float f ) { std::cout<<s<<f<<std::endl; }
	#else
		inline void log( const std::string& s ) { __psp_log( (s+"\n").c_str() ); }
		inline void log( const std::string& s, int i ) { __psp_log( (s+"%d\n").c_str(), i ); }
		inline void log( const std::string& s, const std::string& s2 ) { __psp_log( (s+s2+"\n").c_str() ); }
		inline void log( const std::string& s, float f ) { __psp_log( (s+"%f\n").c_str(), f ); }
	#endif

#else
	inline void log( const std::string& s ) { }
	inline void log( const std::string& s, int i ) { }
	inline void log( const std::string& s, const std::string& s2 ) { }
	inline void log( const std::string& s, float f ) { }
#endif


	namespace force
	{
		#ifndef GIRONA_PSP
			inline void log( const std::string& s ) { std::cout<<s<<std::endl; }
			inline void log( const std::string& s, int i ) { std::cout<<s<<i<<std::endl; }
			inline void log( const std::string& s, const std::string& s2 ) { std::cout<<s<<s2<<std::endl; }
			inline void log( const std::string& s, float f ) { std::cout<<s<<f<<std::endl; }
		#else
			inline void log( const std::string& s ) { __psp_log( (s+"\n").c_str() ); }
			inline void log( const std::string& s, int i ) { __psp_log( (s+"%d\n").c_str(), i ); }
			inline void log( const std::string& s, const std::string& s2 ) { __psp_log( (s+s2+"\n").c_str() ); }
			inline void log( const std::string& s, float f ) { __psp_log( (s+"%f\n").c_str(), f ); }
		#endif
	}
	
}

/*
#ifdef GRN_ENABLE_LOG
	#define log(X) std::cout<<X<<std::endl;
	#define log2(X,Y) std::cout<<X<<Y<<std::endl;
	#define log3(X,Y,Z) std::cout<<X<<Y<<Z<<std::endl;
	#define log4(X,Y,Z,W) std::cout<<X<<Y<<Z<<W<<std::endl;
#else
	#define log(X) {}
	#define log2(X,Y) {}
	#define log3(X,Y,Z) {}
	#define log4(X,Y,Z,W) {}
#endif
*/
 


#endif /*_DATATYPE_H_*/
