#ifndef _GRN_GIRONA_ROOTPIPELINE_H_
#define _GRN_GIRONA_ROOTPIPELINE_H_

#include "Pipeline.h"

#include <string>
#include <list>
#include <map>
#include <algorithm>

namespace grn
{	

	class RootPipeline : public Pipeline
	{
		DECLARE_MODULE(RootPipeline);
		
	public:
		RootPipeline();
		
		void SaveRuntime( const std::string& aFileName ) const;

		/** Output serializer.*/
		virtual void Serialize( std::ostream& s ) const;

		/** Input serializer.*/
		virtual void Deserialize( std::istream& s );

		/** Find a pipeline by name. */
		virtual Pipeline* FindPipeline( std::string aName );

		typedef enum { eNone, eBuild, eLogic, eRender } ExecutionStage;
		
		void SetExecutionStage( Pipeline* aPipeline, ExecutionStage aStage, int aOrder );
		ExecutionStage GetExecutionStage( Pipeline* aPipeline ) const;
		int GetExecutionOrder( Pipeline* aPipeline ) const;
		
		std::list<Pipeline*> iBuildPipelines;
		std::multimap<int, Pipeline*> iLogicPipelines;
		std::list<Pipeline*> iRenderPipelines;
		
	};

}


#endif 
