#ifndef _GRN_VISITOR_H_
#define _GRN_VISITOR_H_


namespace grn
{
	
	class BaseVisitor
	{
	public:
		virtual ~BaseVisitor() {};
	};
	
	
	template < class VisitableType > 
	class Visitor : public virtual BaseVisitor
	{
		public:
			virtual void Visit( VisitableType *aVisited ) = 0;
	};


	class BaseVisitable
	{
	public:
		template < class VisitableType > 
		static void AcceptImpl( VisitableType *aVisited, BaseVisitor *aVisitor )
		{
			Visitor< VisitableType > *lVisitorImpl = dynamic_cast< Visitor< VisitableType >* >( aVisitor );
			if( lVisitorImpl ) lVisitorImpl->Visit( aVisited );
		}
	};
	

}

#endif 
