

#include "Material.h"

using namespace grn;

IMPLEMENT_DATATYPE(Material);
IMPLEMENT_DATATYPE(DepthCodeMaterial);
IMPLEMENT_DATATYPE(UVCodeMaterial);
IMPLEMENT_DATATYPE(PhongMaterial);


PhongMaterial::PhongMaterial(bool aReceiveShadows)
: iReceiveShadows(aReceiveShadows)
{
}


void PhongMaterial::SetTextureParameter( std::string aParamName, Texture* aTexture )
{
	if (!aParamName.compare("DepthBuffer")) rDepthBuffer = aTexture;
}


void PhongMaterial::SetCameraParameter( std::string aParamName, Camera* aCam )
{
	if (!aParamName.compare("View")) 
	{
		iEyePosition = aCam->GetPosition();
	}
	else if (!aParamName.compare("Light")) 
	{
		rDepthMatrix = aCam->GetViewProjectionMatrix();
		iLightPosition = aCam->GetPosition();
	}
}






