

#include "PhysicsEnvironment.h"

#include "modules/physics/AddToPhysicsEnv.h"

using namespace grn;


const grn::DataType grn::PhysicsEnvironment::Type("PhysicsEnvironment");
const grn::DataType grn::CollisionList::Type("CollisionList");
const grn::DataType grn::PhysicsProperties::Type("PhysicsProperties");
const grn::DataType grn::ScenePhysicsProperties::Type("ScenePhysicsProperties");


PhysicsEnvironment::PhysicsEnvironment()
{
	iPhysicsEnvironment = new CcdPhysicsEnvironment();
	iPhysicsEnvironment->setGravity(0.0,0.0,-64.0f);
}


PhysicsEnvironment::~PhysicsEnvironment()
{
	delete iPhysicsEnvironment;
	iPhysicsEnvironment = 0;
}


void PhysicsEnvironment::Update( float aCurrentTime, float aDeltaTime )
{
	iPhysicsEnvironment->beginFrame();
	iPhysicsEnvironment->proceedDeltaTime( aCurrentTime, aDeltaTime );
	iPhysicsEnvironment->endFrame();
}


void PhysicsEnvironment::Build()
{
	delete iPhysicsEnvironment;

	iPhysicsEnvironment = new CcdPhysicsEnvironment();
	iPhysicsEnvironment->setGravity(0.0,0.0,-64.0f);

	for (int i = 0; i < iRawData.size(); i++ )
		AddToPhysicsEnv::CreatePhysicsObjectNew( iRawData[i].first, iRawData[i].second, iPhysicsEnvironment );
		
}

