
#include "RenderTarget.h"

#include "GironaLog.h"

#include "SimdMinMax.h"

#include <iostream>

using namespace grn;


IMPLEMENT_DATATYPE(RenderTarget);
IMPLEMENT_DATATYPE(ScreenRenderTarget);
IMPLEMENT_DATATYPE(Texture);
IMPLEMENT_DATATYPE(OffscreenRenderTarget);


ScreenRenderTarget::ScreenRenderTarget( int aX, int aY, int aWidth, int aHeight, Engine* aEngine )
	: iValid(true)
	, iX(aX)
	, iY(aY)
	, iWidth(aWidth)
	, iHeight(aHeight)
	, rEngine(aEngine)
{
}


void ScreenRenderTarget::Present()
{
	rEngine->SwapBuffers();
}


OffscreenRenderTarget::OffscreenRenderTarget( int aWidth, int aHeight )
	: iValid(true)
	, iWidth(aWidth)
	, iHeight(aHeight)
{
}

