#ifndef DEPTHCODE_SHADERS_H_
#define DEPTHCODE_SHADERS_H_


const char* DEPTH_V_SHADER = 
"\
uniform mat4 uModelTransform;\
\
varying vec4 oPosition;\
\
void main(void)\
{\
	gl_Position = gl_ModelViewProjectionMatrix * (uModelTransform * gl_Vertex);\
	oPosition = gl_Position;\
}\
";


const char* DEPTH_F_SHADER = 
" \
varying vec4 oPosition;\
\
void main(void)\
{\
	float Distance = oPosition.z/oPosition.w*0.5+0.5;\
	gl_FragColor = vec4( Distance, fract(Distance*256.0), fract(Distance*256.0*256.0), 1.0); \
}\
";



#endif /*DEPTHCODE_SHADERS_H_*/
