
#include "EndOfData.h"

#include "Pipeline.h"


#include <sstream>


using namespace grn;


IMPLEMENT_MODULE(EndOfData);

EndOfData::EndOfData( Pipeline* aParent )
: Module(aParent)
{
	setSize(120,30);
	iX = 300;
	iY = 150;
	iType = 0;
	rOutput = 0;
	UpdateSelectedType();
}


void EndOfData::Init()
{
	// Emit EOD	
	rPipeline->EmitEOD( rOutput );
}


void EndOfData::UpdateSelectedType()
{
	if (rOutput)
	{
		// Removes, unlinks and deletes
		RemovePad( rOutput );
	}
	
	DataType lType = rPipeline->FindDataType(iType);
	rOutput = new Module::OutputPad( lType, "EOD" );
	addPad(rOutput);
}


void EndOfData::Serialize( std::ostream& s ) const
{
	// Serialize parent first
	Module::Serialize(s);
	
	s<< rPipeline->FindDataType(iType) <<std::endl;
	
}


void EndOfData::Deserialize( std::istream& s )
{
	// Deserialize parent first
	Module::Deserialize(s);

	DataType l;
	s>> l;
	iType = rPipeline->GetDataTypeID(l);
	
	UpdateSelectedType();
}

