#ifndef _GRN_MODULE_ENDOFDATA_H_
#define _GRN_MODULE_ENDOFDATA_H_

#include "Module.h"
#include "datatypes/BasicTypes.h"

#define GRN_MAX_NAME_LENGTH 80

namespace grn
{
	
	class EndOfData
		: public Module
	{
		DECLARE_MODULE(EndOfData);
	
	protected:	

		/** Generic output pad in this module. */
		OutputPad* rOutput;
		
	public:
	
		EndOfData( Pipeline* aParent );

		virtual void Init();
		
		/** Output serializer.*/
		virtual void Serialize( std::ostream& s ) const;

		/** Input serializer.*/
		virtual void Deserialize( std::istream& s );
		
		/** ID of the data type we will end. */
		short iType;
		
	public:
		void UpdateSelectedType();
		
	};
		
}

#endif
