#ifndef _GRN_MODULE_EXPORT_H_
#define _GRN_MODULE_EXPORT_H_

#include "Module.h"
#include "datatypes/BasicTypes.h"

#define GRN_EXPORT_MAX_NAME_LENGTH 80

namespace grn
{
	
	class Export
		: public Module
	{
		DECLARE_MODULE(Export);
			
	protected:	
	
		/** Generic input pad. This is this module's pad. */
		InputPad* rInput;
		
		/** This is the pad on the pipeline created as a consequence of this module. It is not owned. */
		OutputPad* rPipelinePad;

	public:
	
		Export( Pipeline* aParent );

		virtual void Run();
		
		/** Output serializer.*/
		virtual void Serialize( std::ostream& s ) const;

		/** Input serializer.*/
		virtual void Deserialize( std::istream& s );

		/** This is the ID of the datatype exported by this module. Both of the above pads should be of this type. */		
		short iExportedType;
		
		/** Buffer for blender UI edition of name. */
		char iName[GRN_EXPORT_MAX_NAME_LENGTH];
		
	public:
		void UpdateSelectedType();
		
	};
		
}


#endif
