#ifndef _GRN_MODULE_IF_H_
#define _GRN_MODULE_IF_H_

#include "Module.h"
#include "datatypes/BasicTypes.h"

namespace grn
{
	
	class If
		: public Module
	{
		DECLARE_MODULE(If);
	
	protected:	

		/** Generic output pad. */
		OutputPad* rOutput;
		
		/** Generic input pads. */
		InputPad* rInputTrue;
		InputPad* rInputFalse;

		/** Element selector. */
		tInputPad<Boolean>* riIndex;
		
	public:
	
		If( Pipeline* aParent );

		virtual void Run();
		
		/** Output serializer.*/
		virtual void Serialize( std::ostream& s ) const;

		/** Input serializer.*/
		virtual void Deserialize( std::istream& s );
		
		/** ID of the data type we import through this link. */
		short iImportedType;
		
	public:
		void UpdateSelectedType();
		
	};
		
}


#endif
