#ifndef _GRN_MODULE_IMPORT_H_
#define _GRN_MODULE_IMPORT_H_

#include "Module.h"
#include "datatypes/BasicTypes.h"

#define GRN_MAX_NAME_LENGTH 80

namespace grn
{
	
	class Import
		: public Module
	{
		DECLARE_MODULE(Import);
	
	protected:	

		/** Generic output pad in this module. */
		OutputPad* rOutput;
		
		/** Generic input pad in the pipeline containing this module. It is not owned. */
		InputPad* rPipelinePad;
		
	public:
	
		Import( Pipeline* aParent );

		virtual void Setup();
		virtual void Init();
		
		/** Output serializer.*/
		virtual void Serialize( std::ostream& s ) const;

		/** Input serializer.*/
		virtual void Deserialize( std::istream& s );
		
	public:
		void UpdateSelectedType();
		
		/** ID of the data type we import through this link. */
		short iImportedType;
		
		/** If active, never clear the incoming data, and always emit all of it. */
		short iAccumulate;
		
		/** Buffer for blender UI edition of name. */
		char iName[GRN_MAX_NAME_LENGTH];
		
		/** Accumulated data. */
		std::vector< Pointer<DataObject> > iAccumulated;
	};
		
}


#endif
