#ifndef _GRN_MODULE_MAKEGROUP_H_
#define _GRN_MODULE_MAKEGROUP_H_

#include "Module.h"

#include "datatypes/Object.h"
#include "datatypes/SpotLight.h"
#include "datatypes/Camera.h"
#include "datatypes/PhysicsEnvironment.h"

namespace grn
{
	
	class MakeGroup
		: public Module
	{

		DECLARE_MODULE(MakeGroup);
	
	protected:
	
		tInputPad<Object>* riObjects;
		tInputPad<Camera>* riCameras;
		tInputPad<SpotLight>* riSpotLights;
		tInputPad<PhysicsEnvironment>* riEnvs;
		tOutputPad<Group>* roGroups;
		
	public:
	
		MakeGroup( Pipeline* aParent );

		virtual void Init();
		virtual void Run();
		virtual bool Eod();

		/** Group being built. */
		Pointer<Group> iGroup;
	};
		
}


#endif
