#ifndef _GRN_MODULE_MARKGROUP_H_
#define _GRN_MODULE_MARKGROUP_H_

#include "Module.h"
#include "datatypes/BasicTypes.h"

namespace grn
{
	
	class MarkGroup
		: public Module
	{
		DECLARE_MODULE(MarkGroup);
	
	protected:	

		/** Generic output pad. */
		OutputPad* rOutput;
		
		/** Generic input pad. */
		InputPad* rInput;
		
	public:
	
		MarkGroup( Pipeline* aParent );

		virtual void Run();
		
		/** Output serializer.*/
		virtual void Serialize( std::ostream& s ) const;

		/** Input serializer.*/
		virtual void Deserialize( std::istream& s );
		
	public:
		void UpdateSelectedType();
		
		/** ID of the data type we import through this link. */
		short iImportedType;
		
	};
		
}


#endif
