#ifndef _GRN_MODULE_REPLICATE_H_
#define _GRN_MODULE_REPLICATE_H_

#include "Module.h"
#include "datatypes/BasicTypes.h"

namespace grn
{
	
	class Replicate
		: public Module
	{
		DECLARE_MODULE(Replicate);
	
	protected:	

		/** Generic output pad. */
		OutputPad* rOutput;
		
		/** Generic input pads. */
		InputPad* riSource;
		InputPad* riTimes;

	public:
	
		Replicate( Pipeline* aParent );

		virtual void Run();
		
		/** Output serializer.*/
		virtual void Serialize( std::ostream& s ) const;

		/** Input serializer.*/
		virtual void Deserialize( std::istream& s );
		
	public:
		void UpdateSelectedTypes();
		
		/** ID of the data type we accept as Source through this link. */
		short iSourceType;
		
		/** ID of the data type we accept as times through this link. */
		short iTimesType;
		
	};
		
}


#endif
