#ifndef _GRN_MODULE_SEQUENCESELECT_H_
#define _GRN_MODULE_SEQUENCESELECT_H_

#include "Module.h"
#include "datatypes/BasicTypes.h"

namespace grn
{
	
	class SequenceSelect
		: public Module
	{
		DECLARE_MODULE(SequenceSelect);
	
	protected:	

		/** Generic output pad. */
		OutputPad* rOutput;
		
		/** Generic input pad. */
		InputPad* rInput;

		/** Element index selector. */
		tInputPad<Integer>* riIndex;
		
	public:
	
		SequenceSelect( Pipeline* aParent );

		virtual void Run();
		
		/** Output serializer.*/
		virtual void Serialize( std::ostream& s ) const;

		/** Input serializer.*/
		virtual void Deserialize( std::istream& s );
		
	public:
		void UpdateSelectedType();
		
		/** ID of the data type we import through this link. */
		short iImportedType;
		
	};
		
}


#endif
