
#include "UnGroup.h"

#include "Pipeline.h"
#include "GironaLog.h"


using namespace grn;


IMPLEMENT_MODULE(UnGroup);


UnGroup::UnGroup( Pipeline* aParent )
: Module(aParent)
{
	setSize(100,80);
	iX = 300;
	roObjects = new Module::tOutputPad<grn::Object>( "Objects", this );
	roCameras = new Module::tOutputPad<grn::Camera>( "Cameras", this );
	roSpotLights = new Module::tOutputPad<grn::SpotLight>( "SpotLights", this );
	roEnvs = new Module::tOutputPad<grn::PhysicsEnvironment>( "PhysicsEnvironments", this );
	riGroups = new Module::tInputPad<grn::Group>( "Groups", this );
}


void UnGroup::Run()
{
	while (riGroups->hasData())
	{
		Pointer<Group> iGroup = riGroups->getData(true);

		for ( unsigned int i=0; i<iGroup->iCollections[0].iObjects.size(); i++ ) 
			rPipeline->Emit( roObjects, iGroup->iCollections[0].iObjects[i] );
		for ( unsigned int i=0; i<iGroup->iCollections[1].iObjects.size(); i++ ) 
			rPipeline->Emit( roCameras, iGroup->iCollections[1].iObjects[i] );
		for ( unsigned int i=0; i<iGroup->iCollections[2].iObjects.size(); i++ ) 
			rPipeline->Emit( roSpotLights, iGroup->iCollections[2].iObjects[i] );
		for ( unsigned int i=0; i<iGroup->iCollections[3].iObjects.size(); i++ ) 
			rPipeline->Emit( roEnvs, iGroup->iCollections[3].iObjects[i] );
	}
}


