#ifndef _GRN_MODULE_GETRENDERTEXTURE_H_
#define _GRN_MODULE_GETRENDERTEXTURE_H_

#include "Module.h"

#include "datatypes/BasicTypes.h"
#include "datatypes/RenderTarget.h"

namespace grn
{
	
	class GetRenderTexture
		: public Module
	{
		DECLARE_MODULE(GetRenderTexture);
			
	protected:
	
		tInputPad<RenderTarget>* riTarget;
		tOutputPad<Texture>* roTexture;
		tOutputPad<RenderTarget>* roTarget;
		
	public:
	
		GetRenderTexture( Pipeline* aParent );

		virtual void Link( Engine* aEngine );
		virtual void Run();

		/** Type of the texture to get.*/
		typedef enum { eColor=0, eDepth } TextureType;
		int iType;
		
	protected:
	
		Engine* rEngine;
		
	};
		
}


#endif
