#ifndef _GRN_MODULE_MESHRENDER_H_
#define _GRN_MODULE_MESHRENDER_H_

#include "Module.h"

#include "datatypes/Mesh.h"
#include "datatypes/Material.h"
#include "datatypes/BasicTypes.h"
#include "datatypes/RenderTarget.h"
#include "datatypes/Camera.h"

namespace grn
{
	
	
	class MeshRender
		: public Module
	{

		DECLARE_MODULE(MeshRender);
	
	protected:
	
		tInputPad<Mesh>* riMesh;
		tInputPad<Material>* riMaterial;
		tInputPad<Transform>* riTransform;
		tInputPad<Camera>* riCamera;
		tInputPad<RenderTarget>* riTarget;
		tOutputPad<RenderTarget>* roTarget;
		
		Renderer* rRenderer;
		
	public:
	
		MeshRender( Pipeline* aParent );

		/** */
		void Link( Engine* aEngine );

		/** */
		virtual void Run();

		/** Called every time an input pad has received an end-of-data signal. */
		virtual bool Eod();

	};
		
}


#endif
