
#include "OffscreenTarget.h"

#include "Pipeline.h"
#include "engine/Engine.h"
#include "engine/Renderer.h"
#include "datatypes/BasicTypes.h"

using namespace grn;


IMPLEMENT_MODULE(OffscreenTarget);


OffscreenTarget::OffscreenTarget( Pipeline* aParent )
: Module(aParent)
{
	setSize(60,80);
	rRenderTargetOutput = new Module::tOutputPad<grn::RenderTarget>( "RenderTarget", this );
	rWidthOutput = new Module::tOutputPad<grn::Integer>( "Width", this );
	rHeightOutput = new Module::tOutputPad<grn::Integer>( "Height", this );
	
	iWidth = 512;
	iHeight = 512;
}


void OffscreenTarget::Link( Engine* aEngine )
{
	rEngine = aEngine;
}

void OffscreenTarget::Setup()
{
	iRenderTarget = rEngine->GetRenderer()->NewOffscreenRenderTarget( iWidth, iHeight );
}


void OffscreenTarget::Init()
{
	// Clear. However this should go into a separate module in the future
	iRenderTarget->Clear();	
	rPipeline->Emit( rRenderTargetOutput, static_cast< Pointer<DataObject> >(iRenderTarget) ); 
}



