
#include "OrbitCamera.h"

#include "Pipeline.h"

#include "datatypes/Camera.h"


using namespace grn;


IMPLEMENT_MODULE(OrbitCamera);


OrbitCamera::OrbitCamera( Pipeline* aParent )
: Module(aParent)
{
	setSize(100,60);
	roCamera = new Module::tOutputPad<grn::Camera>( "Camera", this );
	riVolume = new Module::tInputPad<grn::BoundingVolume>( "Volume", this );
}

void OrbitCamera::Setup()
{
	rCamera = new Camera(true);
}

void OrbitCamera::Run()
{ 
	while (riVolume->hasData())
	{
		Pointer<BoundingVolume> lVol = riVolume->getData( false );
		rCamera->ViewVolume( lVol->iAABB );
		rPipeline->Emit( roCamera, rCamera );
	}
}


void OrbitCamera::ProcessMouse( int aDeltaX, int aDeltaY )
{
	rCamera->Orbit( aDeltaX/300.0f, -aDeltaY/300.0f );
}


void OrbitCamera::Link( Engine* aEngine )
{
	aEngine->Register( this );
}

