#ifndef _GRN_MODULE_ORBITCAMERA_H_
#define _GRN_MODULE_ORBITCAMERA_H_

#include "Module.h"
#include "engine/Engine.h"

#include "datatypes/Camera.h"
#include "datatypes/BasicTypes.h"


namespace grn
{
	
	class OrbitCamera
		: public Module
		, public Engine::MouseListener
	{
		DECLARE_MODULE(OrbitCamera);
		
	protected:
		tInputPad<BoundingVolume>* riVolume;
		tOutputPad<Camera>* roCamera;
		Pointer<Camera> rCamera;

	public:

		OrbitCamera( Pipeline* aParent );
		
		virtual void Link( Engine* aEngine );

		virtual void Setup();
		virtual void Run();

	// From Engine::MouseListener	
	public:
		virtual void ProcessMouse( int aDeltaX, int aDeltaY );
	
	};
		
}

#endif
