
#include "PlanarMirror.h"

#include "Pipeline.h"
#include "datatypes/Camera.h"

using namespace grn;


IMPLEMENT_MODULE(PlanarMirror);


PlanarMirror::PlanarMirror( Pipeline* aParent )
: Module(aParent)
{
	setSize(100,80);
	iX = 300;
	riTransform = new Module::tInputPad<grn::Transform>( "In", this );
	roTransform = new Module::tOutputPad<grn::Transform>( "Out", this );
}


void PlanarMirror::Run()
{

	// Fetch object
	Pointer<Transform> lIn;
	while ( lIn = riTransform->getData(true) )
	{	
		Pointer<Transform> lCloned = new Transform();
		/** TODO Mirror disabled. 
		lCloned->iTransform = lIn->iTransform;
		
		MT_Transform lYMirror;
		lYMirror.setIdentity();
		lYMirror.getBasis()[2][2]=-1;
		
		lCloned->iTransform = lYMirror * lIn->iTransform;
		*/
		// emit the render target
		rPipeline->Emit( roTransform, lCloned );
	}
	
}
