
#include "Screen.h"

#include "Pipeline.h"
#include "engine/Engine.h"
#include "engine/Renderer.h"

#include "datatypes/BasicTypes.h"

using namespace grn;


IMPLEMENT_MODULE(Screen);


Screen::Screen( Pipeline* aParent )
: Module(aParent)
{
	setSize(60,80);
	rRenderTargetOutput = new Module::tOutputPad<grn::RenderTarget>( "RenderTarget", this );
	rWidthOutput = new Module::tOutputPad<grn::Integer>( "Width", this );
	rHeightOutput = new Module::tOutputPad<grn::Integer>( "Height", this );
}


void Screen::Setup()
{
	iRenderTarget = rEngine->GetRenderer()->NewScreenRenderTarget( iX, iY, iWidth, iHeight, rEngine );
}


void Screen::Init()
{
	// Clear. However this should go into a separate module in the future
	iRenderTarget->Clear();	
	rPipeline->Emit( rRenderTargetOutput, static_cast< Pointer<DataObject> >(iRenderTarget) ); 
}


void Screen::Link( Engine* aEngine )
{
	rEngine = aEngine;
	rEngine->GetScreenArea(iX,iY,iWidth,iHeight);
}


