
#include "SetCameraPlanes.h"

#include "Pipeline.h"
#include "datatypes/Camera.h"

using namespace grn;


IMPLEMENT_MODULE(SetCameraPlanes);


SetCameraPlanes::SetCameraPlanes( Pipeline* aParent )
: Module(aParent)
{
	setSize(100,60);
	iX = 300;
	riCamera = new Module::tInputPad<Camera>( "Camera", this );
	riVolume = new Module::tInputPad<BoundingVolume>( "Volume", this );
	roCamera = new Module::tOutputPad<Camera>( "Camera", this );
}


void SetCameraPlanes::Run()
{
	while ( AllInputsHaveData() )
	{
		// Fetch camera
		Pointer<Camera> lCam = riCamera->getData( true );
		
		// Fetch volume
		Pointer<BoundingVolume> lVol = riVolume->getData( true );
		
		lCam->SetPlanesFor( lVol->iAABB );
		
		// emit the camera
		rPipeline->Emit( roCamera, lCam );
	}
}
