
#include "SetMaterialCamera.h"

#include "Pipeline.h"

using namespace grn;


IMPLEMENT_MODULE(SetMaterialCamera);


SetMaterialCamera::SetMaterialCamera( Pipeline* aParent )
: Module(aParent)
{
	setSize(120,50); 
	iX = 250;
	riMaterial = new Module::tInputPad<Material>( "Material", this );
	riCamera = new Module::tInputPad<Camera>( "Camera", this );
	roMaterial = new Module::tOutputPad<Material>( "Material", this );
}


void SetMaterialCamera::Run()
{
	while ( (riMaterial->hasData()) && (riCamera->hasData()) )
	{
		Pointer<Material> lMaterial = riMaterial->getData( true );
		Pointer<Camera> lRT = riCamera->getData( false );		
		
		lMaterial->SetCameraParameter( "Light", lRT );

		rPipeline->Emit(roMaterial,lMaterial);
	}
}
