
#include "SetMaterialTexture.h"

#include "Pipeline.h"

using namespace grn;


IMPLEMENT_MODULE(SetMaterialTexture);


SetMaterialTexture::SetMaterialTexture( Pipeline* aParent )
: Module(aParent)
{
	setSize(120,50);
	iX = 250;
	riMaterial = new Module::tInputPad<Material>( "Material", this );
	riTexture = new Module::tInputPad<Texture>( "Texture", this );
	roMaterial = new Module::tOutputPad<Material>( "Material", this );
}


void SetMaterialTexture::Run()
{
	while ( AllInputsHaveData() )
	{
		Pointer<Material> lMaterial = riMaterial->getData( true );
		Pointer<Texture> lT = riTexture->getData( false );		
		
		lMaterial->SetTextureParameter( "DepthBuffer", lT );

		rPipeline->Emit(roMaterial,lMaterial);
	}
}
