
#include "SpotCamera.h"

#include "Pipeline.h"

#include <vector>


using namespace grn;


IMPLEMENT_MODULE(SpotCamera);


SpotCamera::SpotCamera( Pipeline* aParent )
: Module(aParent)
{
	setSize(100,50);
	iX = 250;
	rInput = new Module::tInputPad<SpotLight>( "SpotLight", this );
	rOutput = new Module::tOutputPad<Camera>( "Camera", this );
}


void SpotCamera::Run()
{
	while (rInput->hasData())
	{
		Pointer<SpotLight> lSpot = rInput->getData(true);
		
		Pointer<Camera> lCam = new Camera( true );
		lCam->SetFromTransform( lSpot->iTransform->GetTransform() );
		lCam->SetFOV( lSpot->iAngle/2.0f );
		
		rPipeline->Emit(rOutput,lCam);
	}
}
