
#include "TextureBlit.h"

#include "Pipeline.h"
#include "engine/Engine.h"
#include "engine/Renderer.h"
#include "datatypes/Camera.h"


IMPLEMENT_MODULE(TextureBlit); 

using namespace grn;


TextureBlit::TextureBlit( Pipeline* aParent )
: Module(aParent)
{
	setSize(100,80);
	iX = 300;
	riSource = new Module::tInputPad<grn::Texture>( "Texture", this );
	riTarget = new Module::tInputPad<grn::RenderTarget>( "RenderTarget", this );
	roTarget = new Module::tOutputPad<grn::RenderTarget>( "RenderTarget", this );
}


void TextureBlit::Link( Engine* aEngine )
{
	rEngine = aEngine;
}


void TextureBlit::Run()
{
	
	while ( riSource->hasData() && riTarget->hasData() )
	{
		// Fetch render target, and remove
		Pointer<RenderTarget> lTarget = riTarget->getData( true );

		lTarget->Activate();

		// Fetch object and remove
		Pointer<Texture> lIn = riSource->getData( true );

		rEngine->GetRenderer()->RenderScreenQuad(-1.0,0.5,-0.5,1.0,lIn);

		lTarget->Deactivate();

		// emit the render target
		rPipeline->Emit( roTarget, lTarget );
	}
}
