
#include "AddInteger.h"

#include "Pipeline.h"


using namespace grn;

IMPLEMENT_MODULE(AddInteger);


AddInteger::AddInteger( Pipeline* aParent )
: Module(aParent)
{
	setSize(120,40);
	iX = 300;
	iY = 150;
	riA = new Module::tInputPad<grn::Integer>( "A", this );
	riB = new Module::tInputPad<grn::Integer>( "B", this );
	roResult = new Module::tOutputPad<grn::Integer>( "Result", this );
}


void AddInteger::Run()
{
	if (AllInputsHaveData())
	{
		Pointer<Integer> lA = riA->getData(true);
		Pointer<Integer> lB = riB->getData(true);

		Pointer<Integer> lR = new Integer();
		lR->iValue = lA->iValue+lB->iValue;

		rPipeline->Emit(roResult,lR);
	}
}

