
#include "AddReal.h"

#include "Pipeline.h"


using namespace grn;

IMPLEMENT_MODULE(AddReal);


AddReal::AddReal( Pipeline* aParent )
: Module(aParent)
{
	setSize(120,40);
	iX = 300;
	iY = 150;
	riA = new Module::tInputPad<grn::Real>( "A", this );
	riB = new Module::tInputPad<grn::Real>( "B", this );
	roResult = new Module::tOutputPad<grn::Real>( "Result", this );
	iOperation = eAdd;
}


void AddReal::Run()
{
	if (AllInputsHaveData())
	{
		Pointer<Real> lA = riA->getData(true);
		Pointer<Real> lB = riB->getData(true);

		Pointer<Real> lR = new Real();
		switch (iOperation)
		{
			case eAdd : lR->iValue = lA->iValue+lB->iValue; break;
			case eSubstract : lR->iValue = lA->iValue-lB->iValue; break;
			case eMultiply : lR->iValue = lA->iValue*lB->iValue; break;
			case eDivide : lR->iValue = lA->iValue/lB->iValue; break;
		}
		
		rPipeline->Emit(roResult,lR);
	}
}


void AddReal::Serialize( std::ostream& s ) const
{
	// Serialize parent first
	Module::Serialize(s);
	
	s << iOperation << std::endl;
}


void AddReal::Deserialize( std::istream& s )
{
	// Deserialize parent first
	Module::Deserialize(s);

	s>>iOperation;
}
