#ifndef _GRN_MODULE_ADDREAL_H_
#define _GRN_MODULE_ADDREAL_H_

#include "Module.h"

#include "datatypes/BasicTypes.h"

namespace grn
{
	
	class AddReal
		: public Module
	{
		DECLARE_MODULE(AddReal);	
		
	protected:
	
		tInputPad<grn::Real>* riA;
		tInputPad<grn::Real>* riB;
		tOutputPad<grn::Real>* roResult;
		
	public:
	
		AddReal( Pipeline* aParent );

		virtual void Run();

		/** Output serializer.*/
		virtual void Serialize( std::ostream& s ) const;

		/** Input serializer.*/
		virtual void Deserialize( std::istream& s );


		typedef enum 
		{
			eAdd = 0
			, eSubstract
			, eMultiply
			, eDivide
		} Operation;
		
		short iOperation;
	};
		
}


#endif
