
#include "AddVector.h"

#include "Pipeline.h"


using namespace grn;

IMPLEMENT_MODULE(AddVector);


AddVector::AddVector( Pipeline* aParent )
: Module(aParent)
{
	setSize(120,40);
	iX = 300;
	iY = 150;
	riA = new Module::tInputPad<grn::Vector>( "A", this );
	riB = new Module::tInputPad<grn::Vector>( "B", this );
	roResult = new Module::tOutputPad<grn::Vector>( "Result", this );
}


void AddVector::Run()
{
	if (AllInputsHaveData())
	{
		Pointer<Vector> lA = riA->getData(true);
		Pointer<Vector> lB = riB->getData(true);

		Pointer<Vector> lR = new Vector();
		lR->iValue = lA->iValue+lB->iValue;

		rPipeline->Emit(roResult,lR);
	}
}

