
#include "ClampVector.h"

#include "Pipeline.h"

#include "SimdMinMax.h"

using namespace grn;


IMPLEMENT_MODULE(ClampVector);


ClampVector::ClampVector( Pipeline* aParent )
: Module(aParent)
{
	setSize(120,50);
	iX = 300;
	iY = 150;
	riMin = new Module::tInputPad<grn::Vector>( "MinVector", this );
	riValue = new Module::tInputPad<grn::Vector>( "InputVector", this );
	riMax = new Module::tInputPad<grn::Vector>( "MaxVector", this );
	roClamped = new Module::tOutputPad<grn::Vector>( "Clamped", this );
}


void ClampVector::Run()
{
	if (AllInputsHaveData())
	{
		Pointer<Vector> lMin = riMin->getData(true);
		Pointer<Vector> lMax = riMax->getData(true);
		Pointer<Vector> lValue = riValue->getData(true);

		lValue->iValue = SimdVector3( SimdMin( lMax->iValue.x(), SimdMax( lMin->iValue.x(), lValue->iValue.x() )  )
								   , SimdMin( lMax->iValue.y(), SimdMax( lMin->iValue.y(), lValue->iValue.y() )  )
								   , SimdMin( lMax->iValue.z(), SimdMax( lMin->iValue.z(), lValue->iValue.z() )  )
								   ); 

		rPipeline->Emit(roClamped,lValue);
	}
}

