
#include "CompareReal.h"

#include "Pipeline.h"


using namespace grn;

IMPLEMENT_MODULE(CompareReal);


CompareReal::CompareReal( Pipeline* aParent )
: Module(aParent)
{
	setSize(120,40);
	iX = 300;
	iY = 150;
	riA = new Module::tInputPad<grn::Real>( "A", this );
	riB = new Module::tInputPad<grn::Real>( "B", this );
	roResult = new Module::tOutputPad<grn::Boolean>( "Result", this );
	iOperation = eEqual;
}


void CompareReal::Run()
{
	if (AllInputsHaveData())
	{
		Pointer<Real> lA = riA->getData(true);
		Pointer<Real> lB = riB->getData(true);

		Pointer<Boolean> lR = new Boolean();
		switch (iOperation)
		{
			case eEqual : lR->iValue = ( lA->iValue == lB->iValue); break;
			case eSmaller : lR->iValue = ( lA->iValue < lB->iValue); break;
			case eGreater : lR->iValue = ( lA->iValue > lB->iValue); break;
			case eDifferent : lR->iValue = ( lA->iValue != lB->iValue); break;
		}

		rPipeline->Emit(roResult,lR);
	}
}


void CompareReal::Serialize( std::ostream& s ) const
{
	// Serialize parent first
	Module::Serialize(s);
	
	s << iOperation << std::endl;
}


void CompareReal::Deserialize( std::istream& s )
{
	// Deserialize parent first
	Module::Deserialize(s);

	s>>iOperation;
}
