#ifndef _GRN_MODULE_COMPAREREAL_H_
#define _GRN_MODULE_COMPAREREAL_H_

#include "Module.h"

#include "datatypes/BasicTypes.h"

namespace grn
{
	
	class CompareReal
		: public Module
	{
		DECLARE_MODULE(CompareReal);	
		
	protected:
	
		tInputPad<grn::Real>* riA;
		tInputPad<grn::Real>* riB;
		tOutputPad<grn::Boolean>* roResult;
		
	public:
	
		CompareReal( Pipeline* aParent );

		virtual void Run();

		/** Output serializer.*/
		virtual void Serialize( std::ostream& s ) const;

		/** Input serializer.*/
		virtual void Deserialize( std::istream& s );


		typedef enum 
		{
			eEqual = 0
			, eSmaller
			, eGreater
			, eDifferent
		} Operation;
		
		short iOperation;
	};
		
}


#endif
