
#include "ConstantInteger.h"

#include "Pipeline.h"



using namespace grn;

IMPLEMENT_MODULE(ConstantInteger);


ConstantInteger::ConstantInteger( Pipeline* aParent )
: Module(aParent)
{
	setSize(160,30);
	iX = 300;
	iY = 150;
	roValue = new Module::tOutputPad<grn::Integer>( "Value", this );
	i = 0;
}


void ConstantInteger::Init()
{
	Pointer<Integer> lV = new Integer();
	lV->iValue = i;
	rPipeline->Emit( roValue, lV );
}


void ConstantInteger::Serialize( std::ostream& s ) const
{
	// Serialize parent first
	Module::Serialize(s);
	
	s << i << std::endl;
}


void ConstantInteger::Deserialize( std::istream& s )
{
	// Deserialize parent first
	Module::Deserialize(s);

	s>>i;
}
