
#include "ConstantReal.h"

#include "Pipeline.h"



using namespace grn;

IMPLEMENT_MODULE(ConstantReal);


ConstantReal::ConstantReal( Pipeline* aParent )
: Module(aParent)
{
	setSize(160,30);
	iX = 300;
	iY = 150;
	roValue = new Module::tOutputPad<grn::Real>( "Value", this );
	i = 0;
}


void ConstantReal::Init()
{
	Pointer<Real> lV = new Real();
	lV->iValue = i;
	rPipeline->Emit( roValue, lV );
}


void ConstantReal::Serialize( std::ostream& s ) const
{
	// Serialize parent first
	Module::Serialize(s);
	
	s << i << std::endl;
}


void ConstantReal::Deserialize( std::istream& s )
{
	// Deserialize parent first
	Module::Deserialize(s);

	s>>i;
}
