
#include "ConstantVector.h"

#include "Pipeline.h"


using namespace grn;

IMPLEMENT_MODULE(ConstantVector);


ConstantVector::ConstantVector( Pipeline* aParent )
: Module(aParent)
{
	setSize(160,30);
	iX = 300;
	iY = 150;
	roVector = new Module::tOutputPad<grn::Vector>( "Vector", this );
	ivX = 0.0f;
	ivY = 0.0f;
	ivZ = 0.0f;
}


void ConstantVector::Init()
{
	Pointer<Vector> lV = new Vector();
	lV->iValue.setX( ivX );
	lV->iValue.setY( ivY );
	lV->iValue.setZ( ivZ );
	rPipeline->Emit( roVector, lV );
}


void ConstantVector::Serialize( std::ostream& s ) const
{
	// Serialize parent first
	Module::Serialize(s);
	
	s << ivX << " " << ivY << " " << ivZ << std::endl;
}


void ConstantVector::Deserialize( std::istream& s )
{
	// Deserialize parent first
	Module::Deserialize(s);

	s>>ivX;
	s>>ivY;
	s>>ivZ;
}
