
#include "EnablePipeline.h"

#include "Pipeline.h"


using namespace grn;


IMPLEMENT_MODULE(EnablePipeline);


EnablePipeline::EnablePipeline( Pipeline* aParent )
: Module(aParent)
{
	setSize(160,30);
	iX = 300;
	iY = 150;
	riStatus = new Module::tInputPad<grn::Boolean>( "NewBooleanStatus", this );
	strcpy(iName,"UnNamed");
}


void EnablePipeline::Run()
{
	while (riStatus->hasData())
	{
		Pointer<Boolean> lInObj = riStatus->getData(true);
		
		Pipeline* lP = rPipeline->FindPipeline( iName );
		if (!lP) std::cout<<" WARNING : Failed to find pipeline : "<<iName<<std::endl;
		else lP->LazySetEnabled(lInObj->iValue);
	}
}


void EnablePipeline::Serialize( std::ostream& s ) const
{
	// Serialize parent first
	Module::Serialize(s);
	
	s << iName << std::endl;
}


void EnablePipeline::Deserialize( std::istream& s )
{
	// Deserialize parent first
	Module::Deserialize(s);

	s>>iName;
}

