
#include "KeyEvent.h"

#include "Pipeline.h"


using namespace grn;


IMPLEMENT_MODULE(KeyEvent);


KeyEvent::KeyEvent( Pipeline* aParent )
: Module(aParent)
{
	setSize(160,30);
	iX = 300;
	iY = 150;
	iKey = 0;
	iAction = 0;
	rOutput = new Module::tOutputPad<Boolean>( "Activate", this );
	iKeyStatus = false;
}


void KeyEvent::Link( Engine* aEngine )
{
	aEngine->Register( iKey, this );
}


void KeyEvent::Init()
{
	
	if (iAction==2)
	{
		Pointer<Boolean> lBool = new Boolean();
		lBool->iValue = iKeyStatus;
		rPipeline->Emit( rOutput, lBool );
	}
	
}


void KeyEvent::Serialize( std::ostream& s ) const
{
	// Serialize parent first
	Module::Serialize(s);
	
	s << iKey << std::endl;
	s << iAction << std::endl;
}


void KeyEvent::Deserialize( std::istream& s )
{
	// Deserialize parent first
	Module::Deserialize(s);

	s>>iKey;
	s>>iAction;
}


void KeyEvent::ProcessKey( Engine::KeyCode aKey, bool aValue )
{
	if (   ( (iAction==0)&&(aValue)&&(!iKeyStatus) )
		|| ( (iAction==1)&&(!aValue)&&(iKeyStatus) )
		)
	{
		Pointer<Boolean> lBool = new Boolean();
		lBool->iValue = true;
		rPipeline->Emit( rOutput, lBool );
	}
	
	iKeyStatus = aValue;
}

