#ifndef _GRN_MODULE_KEYEVENT_H_
#define _GRN_MODULE_KEYEVENT_H_

#include "Module.h"
#include "engine/Engine.h"
#include "datatypes/BasicTypes.h"

namespace grn
{
	
	class KeyEvent
		: public Module
		, public Engine::KeyListener
	{
		DECLARE_MODULE(KeyEvent);
	
	protected:
	
		tOutputPad<Boolean>* rOutput;
		
	public:
	
		KeyEvent( Pipeline* aParent );

		virtual void Link( Engine* aEngine );
		
		virtual void Init();
		
		/** Output serializer.*/
		virtual void Serialize( std::ostream& s ) const;

		/** Input serializer.*/
		virtual void Deserialize( std::istream& s );
		
		/** Code of the key to watch. */
		short iKey;
		
		/** Action of the key to watch: Down,Up or Pressed*/
		short iAction;
	
		/** Status of the key, in other words, if it currently pressed or not. */
		bool iKeyStatus;
		

	// From Engine::KeyListener
	public:
		void ProcessKey( Engine::KeyCode aKey, bool aPressed );
		
	};
		
}


#endif
