
#include "MultiplyVector.h"

#include "Pipeline.h"


using namespace grn;

IMPLEMENT_MODULE(MultiplyVector);


MultiplyVector::MultiplyVector( Pipeline* aParent )
: Module(aParent)
{
	setSize(120,40);
	iX = 300;
	iY = 150;
	riReal = new Module::tInputPad<grn::Real>( "Real", this );
	riVector = new Module::tInputPad<grn::Vector>( "Vector", this );
	roResult = new Module::tOutputPad<grn::Vector>( "Result", this );
}


void MultiplyVector::Run()
{
	if (AllInputsHaveData())
	{
		Pointer<Real> lReal = riReal->getData(true);
		Pointer<Vector> lVector = riVector->getData(true);

		Pointer<Vector> lR = new Vector();
		lR->iValue = lReal->iValue*lVector->iValue;

		rPipeline->Emit(roResult,lR);
	}
}

