
#include "OperateBoolean.h"

#include "Pipeline.h"


using namespace grn;

IMPLEMENT_MODULE(OperateBoolean);


OperateBoolean::OperateBoolean( Pipeline* aParent )
: Module(aParent)
{
	setSize(120,40);
	iX = 300;
	iY = 150;
	riA = new Module::tInputPad<grn::Boolean>( "A", this );
	riB = new Module::tInputPad<grn::Boolean>( "B", this );
	roResult = new Module::tOutputPad<grn::Boolean>( "Result", this );
	iOperation = eAnd;
}


void OperateBoolean::Run()
{
	if (AllInputsHaveData())
	{
		Pointer<Boolean> lA = riA->getData(true);
		Pointer<Boolean> lB = riB->getData(true);

		Pointer<Boolean> lR = new Boolean();
		switch (iOperation)
		{
			case eAnd : lR->iValue = lA->iValue && lB->iValue; break;
			case eOr : lR->iValue = lA->iValue || lB->iValue; break;
			case eXor : lR->iValue = lA->iValue ^ lB->iValue; break; 
		}
		
		rPipeline->Emit(roResult,lR);
	}
}


void OperateBoolean::Serialize( std::ostream& s ) const
{
	// Serialize parent first
	Module::Serialize(s);
	
	s << iOperation << std::endl;
}


void OperateBoolean::Deserialize( std::istream& s )
{
	// Deserialize parent first
	Module::Deserialize(s);

	s>>iOperation;
}
