#ifndef _GRN_MODULE_OPERATEBOOLEAN_H_
#define _GRN_MODULE_OPERATEBOOLEAN_H_

#include "Module.h"

#include "datatypes/BasicTypes.h"

namespace grn
{
	
	class OperateBoolean
		: public Module
	{
		DECLARE_MODULE(OperateBoolean);	
		
	protected:
	
		tInputPad<grn::Boolean>* riA;
		tInputPad<grn::Boolean>* riB;
		tOutputPad<grn::Boolean>* roResult;
		
	public:
	
		OperateBoolean( Pipeline* aParent );

		virtual void Run();

		/** Output serializer.*/
		virtual void Serialize( std::ostream& s ) const;

		/** Input serializer.*/
		virtual void Deserialize( std::istream& s );


		typedef enum 
		{
			eAnd = 0
			, eOr
			, eXor
		} Operation;
		
		short iOperation;
	};
		
}


#endif
