
#include "SelectObject.h"

#include "GironaLog.h"
#include "Pipeline.h"


using namespace grn;


IMPLEMENT_MODULE(SelectObject);


SelectObject::SelectObject( Pipeline* aParent )
: Module(aParent)
{
	setSize(160,30);
	iX = 300;
	iY = 150;
	riObjects = new Module::tInputPad<grn::Object>( "InputObjects", this );
	roObject = new Module::tOutputPad<grn::Object>( "OutputObject", this );
	strcpy(iName,"UnNamed");
	iCriteria = 0;
}


void SelectObject::Run()
{
	while (riObjects->hasData())
	{
		Pointer<Object> lInObj = riObjects->getData(true);
		
		if (iCriteria==0)
		{
			if (lInObj->iName)
				if ( lInObj->iName->iValue==iName)
					rPipeline->Emit(roObject,lInObj);
		}
		else
		{
			if (lInObj->HasProperty(iName))
			{
				rPipeline->Emit(roObject,lInObj);
				log(" [selectobject] emited :      ",lInObj->iName->iValue);
			}
		}
	}
}


void SelectObject::Serialize( std::ostream& s ) const
{
	// Serialize parent first
	Module::Serialize(s);
	s << iCriteria << std::endl;
	s << iName << std::endl;
}


void SelectObject::Deserialize( std::istream& s )
{
	// Deserialize parent first
	Module::Deserialize(s);
	s>>iCriteria;
	s>>iName;
}

