#ifndef _GRN_MODULE_SELECTOBJECT_H_
#define _GRN_MODULE_SELECTOBJECT_H_

#include "Module.h"

#include "datatypes/BasicTypes.h"
#include "datatypes/Object.h"

namespace grn
{
	
	class SelectObject
		: public Module
	{
		DECLARE_MODULE(SelectObject);
	
	protected:
	
		tInputPad<grn::Object>* riObjects;
		tOutputPad<grn::Object>* roObject;
		
	public:
	
		SelectObject( Pipeline* aParent );

		virtual void Run();
		
		/** Output serializer.*/
		virtual void Serialize( std::ostream& s ) const;

		/** Input serializer.*/
		virtual void Deserialize( std::istream& s );

	public:
		/** Filter by name or by property. */
		short iCriteria;
		
		/** Buffer for blender UI edition of name. */
		char iName[80];
		
	};
		
}


#endif
