
#include "SetObjectPosition.h"

#include "Pipeline.h"


using namespace grn;


IMPLEMENT_MODULE(SetObjectPosition);


SetObjectPosition::SetObjectPosition( Pipeline* aParent )
: Module(aParent)
{
	setSize(160,30);
	iX = 300;
	iY = 150;
	riObjects = new Module::tInputPad<grn::Object>( "InputObjects", this );
	riKey = new Module::tInputPad<grn::Boolean>( "Pulse", this );
}


void SetObjectPosition::Run()
{
	if (riKey->hasData())
	{
		// temp discard value
		riKey->getData(true);
		
		while (riObjects->hasData())
		{
			Pointer<Object> lInObj = riObjects->getData(true);
	
			//lInObj->iTransform->iTransform.translate( SimdVector3(0.0,0.0,1.0f) );		
			if (lInObj->iPhysicsController)
				lInObj->iPhysicsController->SetLinearVelocity( 0.0, 0.0, 1.0, true );
		}
	}
}


