
#include "TimeStep.h"

#include "Pipeline.h"


using namespace grn;

IMPLEMENT_MODULE(TimeStep);


TimeStep::TimeStep( Pipeline* aParent )
: Module(aParent)
{
	setSize(60,30);
	iX = 300;
	iY = 150;
	ro = new Module::tOutputPad<grn::Real>( "TimeStep", this );
}


void TimeStep::Init()
{
	Pointer<Real> lR = new Real();
	lR->iValue = rEngine->GetDeltaTime();
	rPipeline->Emit(ro,lR);
}

void TimeStep::Link( Engine* aEngine )
{
	rEngine = aEngine;
}
