
#include "VariableBoolean.h"

#include "Pipeline.h"



using namespace grn;

IMPLEMENT_MODULE(VariableBoolean);


VariableBoolean::VariableBoolean( Pipeline* aParent )
: Module(aParent)
{
	setSize(160,30);
	iX = 300;
	iY = 150;
	roValue = new Module::tOutputPad<grn::Boolean>( "Value", this );
	riValue = new Module::tInputPad<grn::Boolean>( "NewValue", this );
	i = 0;
	initial = i;
}


void VariableBoolean::Setup()
{
	i = initial;
}


void VariableBoolean::Init()
{
	Pointer<Boolean> lV = new Boolean();
	lV->iValue = (i!=0);
	rPipeline->Emit( roValue, lV );
}


void VariableBoolean::Run()
{
	// Process all input vectors. It only stores the last one received.
	// Don't emit. Keep the value for the next iteration.
	while (AllInputsHaveData())
	{
		Pointer<Boolean> lNewValue = riValue->getData(true);
		i = lNewValue->iValue;
	}
}


void VariableBoolean::Serialize( std::ostream& s ) const
{
	// Serialize parent first
	Module::Serialize(s);
	
	s << initial << std::endl;
}


void VariableBoolean::Deserialize( std::istream& s )
{
	// Deserialize parent first
	Module::Deserialize(s);

	s>>initial;
}
