
#include "VariableInteger.h"

#include "Pipeline.h"



using namespace grn;

IMPLEMENT_MODULE(VariableInteger);


VariableInteger::VariableInteger( Pipeline* aParent )
: Module(aParent)
{
	setSize(160,30);
	iX = 300;
	iY = 150;
	roValue = new Module::tOutputPad<grn::Integer>( "Value", this );
	riValue = new Module::tInputPad<grn::Integer>( "NewValue", this );
	i = 0;
	initial = i;
}


void VariableInteger::Setup()
{
	i = initial;
}


void VariableInteger::Init()
{
	Pointer<Integer> lV = new Integer();
	lV->iValue = i;
	rPipeline->Emit( roValue, lV );
}


void VariableInteger::Run()
{
	// Process all input vectors. It only stores the last one received.
	// Don't emit. Keep the value for the next iteration.
	while (AllInputsHaveData())
	{
		Pointer<Integer> lNewValue = riValue->getData(true);
		i = lNewValue->iValue;
	}
}


void VariableInteger::Serialize( std::ostream& s ) const
{
	// Serialize parent first
	Module::Serialize(s);
	
	s << initial << std::endl;
}


void VariableInteger::Deserialize( std::istream& s )
{
	// Deserialize parent first
	Module::Deserialize(s);

	s>>initial;
}
