
#include "VariableReal.h"

#include "Pipeline.h"



using namespace grn;

IMPLEMENT_MODULE(VariableReal);


VariableReal::VariableReal( Pipeline* aParent )
: Module(aParent)
{
	setSize(160,30);
	iX = 300;
	iY = 150;
	roValue = new Module::tOutputPad<grn::Real>( "Value", this );
	riValue = new Module::tInputPad<grn::Real>( "NewValue", this );
	i = 0.0f;
	initial = i;
}


void VariableReal::Setup()
{
	i = initial;
}


void VariableReal::Init()
{
	Pointer<Real> lV = new Real();
	lV->iValue = i;
	rPipeline->Emit( roValue, lV );
}


void VariableReal::Run()
{
	// Process all input vectors. It only stores the last one received.
	// Don't emit. Keep the value for the next iteration.
	while (AllInputsHaveData())
	{
		Pointer<Real> lNewValue = riValue->getData(true);
		i = lNewValue->iValue;
	}
}


void VariableReal::Serialize( std::ostream& s ) const
{
	// Serialize parent first
	Module::Serialize(s);
	
	s << initial << std::endl;
}


void VariableReal::Deserialize( std::istream& s )
{
	// Deserialize parent first
	Module::Deserialize(s);

	s>>initial;
}
