#ifndef _GRN_MODULE_VARIABLEVECTOR_H_
#define _GRN_MODULE_VARIABLEVECTOR_H_

#include "Module.h"

#include "datatypes/BasicTypes.h"

namespace grn
{
	
	class VariableVector
		: public Module
	{
		DECLARE_MODULE(VariableVector);	
		
	protected:
	
		tOutputPad<grn::Vector>* roVector;
		tInputPad<grn::Vector>* riVector;
		
	public: 
	
		VariableVector( Pipeline* aParent );

		virtual void Setup();
		virtual void Init();
		virtual void Run();

		/** Output serializer.*/
		virtual void Serialize( std::ostream& s ) const;

		/** Input serializer.*/
		virtual void Deserialize( std::istream& s );

		float ivX,ivY,ivZ;
		float ivXinitial,ivYinitial,ivZinitial;
	};
		
}


#endif
