
#include "GetBoundingVolume.h"

#include "Pipeline.h"
#include "datatypes/Camera.h"


using namespace grn;


IMPLEMENT_MODULE(GetBoundingVolume);


GetBoundingVolume::GetBoundingVolume( Pipeline* aParent )
: Module(aParent)
{
	setSize(60,100);
	iX = 300;
	riObjects = new Module::tInputPad<grn::Object>( "Objects", this );
	roObjects = new Module::tOutputPad<grn::Object>( "Objects", this );
	roVolume = new Module::tOutputPad<grn::BoundingVolume>( "BoundingVolume", this );
}


void GetBoundingVolume::Init()
{
	iBVol = new BoundingVolume();
}


void GetBoundingVolume::Run()
{
	while ( riObjects->hasData() )
	{
		// Fetch object
		Pointer<Object> lIn = riObjects->getData( true );
		iBVol->iAABB.Bound( lIn->iAABB );
		rPipeline->Emit( roObjects, lIn );	
	}
}


bool GetBoundingVolume::Eod()
{
	// emit the volume
	rPipeline->Emit( roVolume, iBVol );
	// Make a new one
	Init();
	
	return Module::Eod();
}

