#ifndef _GRN_MODULE_LINKHIERARCHY_H_
#define _GRN_MODULE_LINKHIERARCHY_H_

#include "Module.h"

#include "datatypes/Object.h"
#include "datatypes/BasicTypes.h"

#include <list>


namespace grn
{
	
	class LinkHierarchy
		: public Module
	{
		DECLARE_MODULE(LinkHierarchy);
	
	protected:
	
		tInputPad<Object>* riObjects;
		tOutputPad<Object>* roObjects;
		
	public:
	
		LinkHierarchy( Pipeline* aParent );

		virtual void Init();
		virtual void Run();

	protected:
		typedef std::list< Pointer<Object> > ObjectList;
		ObjectList iObjectsProcessed;
		ObjectList iObjectsPending;
	};
		
}


#endif
