
#include "ObjectForm.h"

#include "Pipeline.h"
#include "datatypes/Camera.h"


using namespace grn;


IMPLEMENT_MODULE(ObjectForm);


ObjectForm::ObjectForm( Pipeline* aParent )
: Module(aParent)
{
	setSize(100,80);
	iX = 300;
	riMesh = new Module::tInputPad<grn::Mesh>( "Mesh", this );
	riMaterial = new Module::tInputPad<grn::Material>( "Material", this );
	riTransform = new Module::tInputPad<grn::Transform>( "Transform", this );
	riName = new Module::tInputPad<grn::String>( "Name", this );
	riParentName = new Module::tInputPad<grn::String>( "ParentName", this );
	riProperties = new Module::tInputPad<grn::StringList>( "Properties", this );
	roObject = new Module::tOutputPad<grn::Object>( "Object", this );
}


void ObjectForm::Run()
{
	while ( AllInputsHaveData() )
	{
		// Fetch data and remove
		Pointer<Mesh> lMesh = riMesh->getData( true );
		Pointer<Transform> lTransform = riTransform->getData( true);
		Pointer<Material> lMaterial = riMaterial->getData( true );
		Pointer<String> lName = riName->getData( true );
		Pointer<String> lParentName = riParentName->getData( true );
		Pointer<StringList> lProperties = riProperties->getData( true );
		
		Pointer<Object> lObject = new Object();
		lObject->iMesh = lMesh;
		lObject->iInstanceTransform = lTransform;
		lObject->iMaterial = lMaterial;
		lObject->iName = lName;
		lObject->iParentName = lParentName;
		lObject->iProperties = lProperties;
		
		lObject->UpdateBoundingVolume();
		
		rPipeline->Emit(roObject, lObject);
	}
}
