
#include "ObjectParts.h"

#include "Pipeline.h"
#include "datatypes/Camera.h"

using namespace grn;


IMPLEMENT_MODULE(ObjectParts);


ObjectParts::ObjectParts( Pipeline* aParent )
: Module(aParent)
{
	setSize(100,80);
	iX = 300;
	roMesh = new Module::tOutputPad<grn::Mesh>( "Mesh", this );
	roMaterial = new Module::tOutputPad<grn::Material>( "Material", this );
	roTransform = new Module::tOutputPad<grn::Transform>( "Transform", this );
	riObject = new Module::tInputPad<grn::Object>( "Object", this );
}


void ObjectParts::Run()
{
	while ( riObject->hasData() )
	{
		// Fetch object and remove
		Pointer<Object> lObject = riObject->getData( true );
		
		rPipeline->Emit( roMesh, lObject->iMesh );
		rPipeline->Emit( roMaterial, lObject->iMaterial );
		
		Pointer<Transform> lT = new Transform();
		lObject->GetWorldTransform(lT->iTransform);
		
		rPipeline->Emit( roTransform, lT );
	}
}
