
#ifndef GIRONA_PLAYERBLENDERENGINE_H_
#define GIRONA_PLAYERBLENDERENGINE_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "girona/engine/Engine.h"
#include "girona/RootPipeline.h"
#include "girona/GironaLog.h"

#include <GL/glut.h>

#include <vector>
#include <map>

class PlayerEngine : public grn::Engine
{
public:

	PlayerEngine( grn::RootPipeline* aP, grn::Renderer* aR)
	: grn::Engine(aP,aR)
	{
		// Fetch current mouse position
		//getmouse(iMousePos);
		
		// init some key codes
		sGlutKeyMap[27] = grn::Engine::eEscape;
		sGlutKeyMap[(int)' '] = grn::Engine::eSpace;
		sGlutKeyMap[(int)'Q'] = grn::Engine::eQ;
		sGlutKeyMap[(int)'q'] = grn::Engine::eQ;
		sGlutKeyMap[(int)'W'] = grn::Engine::eW;
		sGlutKeyMap[(int)'w'] = grn::Engine::eW;
		sGlutKeyMap[(int)'E'] = grn::Engine::eE;
		sGlutKeyMap[(int)'e'] = grn::Engine::eE;
		sGlutKeyMap[(int)'A'] = grn::Engine::eA;
		sGlutKeyMap[(int)'a'] = grn::Engine::eA;
		sGlutKeyMap[(int)'S'] = grn::Engine::eS;
		sGlutKeyMap[(int)'s'] = grn::Engine::eS;
		sGlutKeyMap[(int)'D'] = grn::Engine::eD;
		sGlutKeyMap[(int)'d'] = grn::Engine::eD;		
		sGlutKeyMap[(int)'Z'] = grn::Engine::eZ;
		sGlutKeyMap[(int)'z'] = grn::Engine::eZ;
		sGlutKeyMap[(int)'X'] = grn::Engine::eX;
		sGlutKeyMap[(int)'x'] = grn::Engine::eX;
		sGlutKeyMap[(int)'C'] = grn::Engine::eC;
		sGlutKeyMap[(int)'c'] = grn::Engine::eC;

		sGlutSpecialKeyMap[GLUT_KEY_LEFT] = grn::Engine::eLeft;
		sGlutSpecialKeyMap[GLUT_KEY_RIGHT] = grn::Engine::eRight;
		sGlutSpecialKeyMap[GLUT_KEY_UP] = grn::Engine::eUp;
		sGlutSpecialKeyMap[GLUT_KEY_DOWN] = grn::Engine::eDown;

	}

	void SwapBuffers()
	{
		glutSwapBuffers();
	}

	grn::Engine::KeyCode sGlutKeyMap[256];
	grn::Engine::KeyCode sGlutSpecialKeyMap[256];


};


#endif /*BLENDERENGINE_H_*/
