
#ifndef GIRONA_GU_PLAYERBLENDERENGINE_H_
#define GIRONA_GU_PLAYERBLENDERENGINE_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "girona/engine/Engine.h"
#include "girona/RootPipeline.h"

#include <vector>
#include <map>

#include <pspkernel.h>
#include <pspdisplay.h>
#include <pspdebug.h>
#include <pspctrl.h>
#include <pspgu.h>

#include "girona/GironaLog.h"


class PlayerEngine : public grn::Engine
{
public:

	PlayerEngine( grn::RootPipeline* aP, grn::Renderer* aR)
	: grn::Engine(aP,aR)
	{
	    //setup Pad
	    oldButtons = 0;
	    sceCtrlSetSamplingCycle(0);
	    sceCtrlSetSamplingMode(0);
	}

	void SwapBuffers()
	{
		sceGuFinish();
		//__psp_log("------------------- finish \n");

		sceGuSync(0,0);

		sceDisplayWaitVblankStart();
		sceGuSwapBuffers();

	}


	void ProcessEvents()
	{
		sceCtrlReadBufferPositive(&pad, 1);
		if(oldButtons != pad.Buttons)
		{
			//__psp_log("[engine] buttons changed.\n");
			
			// X to SPACE
			if ( (pad.Buttons & PSP_CTRL_CROSS) != (oldButtons & PSP_CTRL_CROSS) ) 
				ProcessKey( grn::Engine::eSpace, (pad.Buttons & PSP_CTRL_CROSS) );

			// Up
			if ( (pad.Buttons & PSP_CTRL_UP) != (oldButtons & PSP_CTRL_UP) ) 
				ProcessKey( grn::Engine::eUp, (pad.Buttons & PSP_CTRL_UP) );

			// Down
			if ( (pad.Buttons & PSP_CTRL_DOWN) != (oldButtons & PSP_CTRL_DOWN) ) 
				ProcessKey( grn::Engine::eDown, (pad.Buttons & PSP_CTRL_DOWN) );

			// Left
			if ( (pad.Buttons & PSP_CTRL_LEFT) != (oldButtons & PSP_CTRL_LEFT) ) 
				ProcessKey( grn::Engine::eLeft, (pad.Buttons & PSP_CTRL_LEFT) );

			// Right
			if ( (pad.Buttons & PSP_CTRL_RIGHT) != (oldButtons & PSP_CTRL_RIGHT) ) 
				ProcessKey( grn::Engine::eRight, (pad.Buttons & PSP_CTRL_RIGHT) );

		}
		oldButtons = pad.Buttons;
	}

protected:

    SceCtrlData pad;
    u32 oldButtons;

};


#endif /*BLENDERENGINE_H_*/
