
#ifndef GIRONA_BLENDERENGINE_H_
#define GIRONA_BLENDERENGINE_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "girona/girona.h"
#include "girona/engine/Engine.h"
#include "girona/RootPipeline.h"
#include "girona/datatypes/Camera.h"

#include <signal.h>

#include "mydevice.h"

	/***/
extern "C" {

#include "DNA_view3d_types.h"
#include "DNA_screen_types.h"
#include "BKE_global.h"
#include "BIF_screen.h"
#include "BIF_scrarea.h"
#include "BIF_mywindow.h"

#include "PIL_time.h"	

#include "BKE_main.h"	
#include "BLI_blenlib.h"
#include "DNA_scene_types.h"

}
	/***/

#include <vector>
#include <map>

class BlenderEngine : public grn::Engine
{
public:

	BlenderEngine( grn::RootPipeline* aP, grn::Renderer* aR )
	: grn::Engine(aP,aR)
	{
		// Fetch current mouse position
		getmouseco_sc(iMousePos);
		
		// init some key codes
		sBlenderKeyMap[(int)ESCKEY] = grn::Engine::eEscape;
		sBlenderKeyMap[(int)SPACEKEY] = grn::Engine::eSpace;
		sBlenderKeyMap[(int)QKEY] = grn::Engine::eQ;
		sBlenderKeyMap[(int)WKEY] = grn::Engine::eW;
		sBlenderKeyMap[(int)EKEY] = grn::Engine::eE;
		sBlenderKeyMap[(int)AKEY] = grn::Engine::eA;
		sBlenderKeyMap[(int)SKEY] = grn::Engine::eS;
		sBlenderKeyMap[(int)DKEY] = grn::Engine::eD;
		sBlenderKeyMap[(int)ZKEY] = grn::Engine::eZ;
		sBlenderKeyMap[(int)XKEY] = grn::Engine::eX;
		sBlenderKeyMap[(int)CKEY] = grn::Engine::eC;
		
		sBlenderKeyMap[(int)LEFTARROWKEY] = grn::Engine::eLeft;
		sBlenderKeyMap[(int)RIGHTARROWKEY] = grn::Engine::eRight;
		sBlenderKeyMap[(int)UPARROWKEY] = grn::Engine::eUp;
		sBlenderKeyMap[(int)DOWNARROWKEY] = grn::Engine::eDown;
	}

	void SwapBuffers()
	{
		// Blenders function to swap back and front buffers
		myswapbuffers();	
	}

	KeyCode sBlenderKeyMap[512];


protected:
	short iMousePos[2];

};


#endif /*BLENDERENGINE_H_*/
