
#include "BlenderTypes.h"

using namespace grn;

const DataType BlenderScene::Type("BlenderScene");
const DataType BlenderObject::Type("BlenderObject");
const DataType BlenderMesh::Type("BlenderMesh");
const DataType BlenderMaterial::Type("BlenderMaterial");


SimdTransform GetBlenderObjectTransform( ::Object* blenderobject)
{
	SimdVector3 pos = SimdPoint3(
		blenderobject->loc[0]+blenderobject->dloc[0],
		blenderobject->loc[1]+blenderobject->dloc[1],
		blenderobject->loc[2]+blenderobject->dloc[2]
	);
	SimdQuaternion rot = SimdQuaternion(
		blenderobject->rot[0],
		blenderobject->rot[1],
		blenderobject->rot[2]
	);
	SimdVector3 scale = SimdVector3(
		blenderobject->size[0],
		blenderobject->size[1],
		blenderobject->size[2]
	);
	
	SimdTransform lT = SimdTransform( rot, pos );
	//lT.scale(scale.x());
	return lT;
}

Pointer<Transform> BlenderObject::ExtractTransform()
{
	Pointer<Transform> lTrans = new Transform();

/*
	SimdTransform lThisToWorld = GetBlenderObjectTransform(rObject);

	if (rObject->parent)
	{
		SimdTransform lThisToWorld = GetBlenderObjectTransform(rObject);
		SimdTransform lParentToWorld = GetBlenderObjectTransform(rObject);
		SimdTransform lWorldToParent;
		lWorldToParent.invert(lParentToWorld);
		lTrans->iTransform = lWorldToParent * lThisToWorld;
	}
	else
*/
	SimdPoint3 lTranslation = SimdPoint3(
		rObject->loc[0]+rObject->dloc[0],
		rObject->loc[1]+rObject->dloc[1],
		rObject->loc[2]+rObject->dloc[2]
	);
	
	SimdQuaternion lRotation = SimdQuaternion( rObject->rot[0], rObject->rot[1], rObject->rot[2] );
	lTrans->iTransform = SimdTransform( lRotation, lTranslation );
	
	return lTrans;
}

