
#ifndef _GRN_BLENDERTYPES_H_
#define _GRN_BLENDERTYPES_H_

#include "DataType.h"

#include "datatypes/BasicTypes.h"

#include <DNA_scene_types.h>
#include <DNA_object_types.h>
#include <DNA_mesh_types.h>
#include <DNA_meshdata_types.h>
#include <DNA_material_types.h>


namespace grn
{
	
	class BlenderMesh: public DataObject
	{
		DECLARE_DATATYPE(BlenderMesh);

	public:		
		/** Not owned reference to the mesh in blender space. */
		::Mesh* rMesh;
		
	};

	
	class BlenderObject: public DataObject
	{
		DECLARE_DATATYPE(BlenderObject);

	public:
		
		/** Not owned reference to the object struct in blender space. */
		::Object* rObject;
		
		Pointer<Transform> ExtractTransform();
		
	};

	
	class BlenderScene: public DataObject
	{
		DECLARE_DATATYPE(BlenderScene);
	public:
		
		/** Not owned reference to the scene struct in blender space. */
		::Scene* rScene;
		
	};

	
	class BlenderMaterial: public DataObject
	{
		DECLARE_DATATYPE(BlenderMaterial);
	public:

		/** Not owned reference to the material struct in blender space. */
		::Material* rMaterial;
	};
	
	
}

#endif /*_BLENDERMESH_H_*/
