
#include "CameraConvert.h"

#include "Pipeline.h"

using namespace grn;


IMPLEMENT_MODULE(CameraConvert);


CameraConvert::CameraConvert( Pipeline* aParent )
: Module(aParent)
{
	setSize(100,50);
	iX = 250;
	rInput = new Module::tInputPad<grn::BlenderObject>( "BlenderObject", this );
	rOutput = new Module::tOutputPad<grn::Camera>( "Camera", this );
}


void CameraConvert::Run()
{
	while (rInput->hasData())
	{
		Pointer<BlenderObject> lInObject = rInput->getData( true );
		Pointer<Transform> lTrans = lInObject->ExtractTransform();
		
		Pointer<Camera> lCam = new Camera( true );
		lCam->SetFromTransform( lTrans->GetTransform() );
		lCam->SetFOV( SIMD_PI/3.3f );

		rPipeline->Emit(rOutput,lCam);
	}
}
