#ifndef _GRN_MODULE_BLENDEROBJECTFILTER_H_
#define _GRN_MODULE_BLENDEROBJECTFILTER_H_

#include "Module.h"

#include "datatypes/BasicTypes.h"
#include "datatypes/BlenderTypes.h"

namespace grn
{
	
	class BlenderObjectFilter
		: public Module
	{
	public:
		DECLARE_MODULE(BlenderObjectFilter);
	
	protected:
	
		tInputPad<BlenderObject>* rInput;
		tOutputPad<BlenderObject>* rOutput;
		
	public:
	
		BlenderObjectFilter( Pipeline* aParent );

		virtual void Run();
		
		/** Output serializer.*/
		virtual void Serialize( std::ostream& s ) const;

		/** Input serializer.*/
		virtual void Deserialize( std::istream& s );

		/** Index of the subtype to filter*/
		short iType;
		
	};
		
}


#endif
