#ifndef _GRN_MODULE_BLENDEROBJECTPARTS_H_
#define _GRN_MODULE_BLENDEROBJECTPARTS_H_

#include "Module.h"

#include "datatypes/BasicTypes.h"
#include "datatypes/BlenderTypes.h"
#include "datatypes/PhysicsEnvironment.h"

namespace grn
{
	
	class BlenderObjectParts
		: public Module
	{
		DECLARE_MODULE(BlenderObjectParts);
	
	protected:
	
		tInputPad<BlenderObject>* rInput;
		tOutputPad<BlenderMesh>* roMesh;
		tOutputPad<BlenderMaterial>* roMaterial;
		tOutputPad<Transform>* roTransform;
		tOutputPad<String>* roName;
		tOutputPad<String>* roParentName;
		tOutputPad<StringList>* roProperties;
		tOutputPad<PhysicsProperties>* roPhysics;
		
	public:
	
		BlenderObjectParts( Pipeline* aParent );

		virtual void Run();

	};
		
}


#endif
