
#include "BlenderSceneParts.h"

#include "Pipeline.h"

#include "BKE_main.h"
#include "BKE_global.h"

/* This list includes only data type definitions */
#include "DNA_object_types.h"
#include "DNA_material_types.h"
#include "DNA_image_types.h"
#include "DNA_lamp_types.h"
#include "DNA_group_types.h"
#include "DNA_scene_types.h"
#include "DNA_camera_types.h"
#include "DNA_property_types.h"
#include "DNA_text_types.h"
#include "DNA_sensor_types.h"
#include "DNA_controller_types.h"
#include "DNA_actuator_types.h"
#include "DNA_mesh_types.h"
#include "DNA_meshdata_types.h"
#include "DNA_view3d_types.h"
#include "DNA_world_types.h"
#include "DNA_sound_types.h"
#include "DNA_key_types.h"
#include "DNA_armature_types.h"


using namespace grn;


IMPLEMENT_MODULE(BlenderSceneParts);



BlenderSceneParts::BlenderSceneParts( Pipeline* aParent )
: Module(aParent)
{
	setSize(160,40);
	
	riScenesPad = new Module::tInputPad<BlenderScene>( "BlenderScenes", this );

	roObjectsPad = new Module::tOutputPad<BlenderObject>( "BlenderObjects", this );
	roPropsPad = new Module::tOutputPad<ScenePhysicsProperties>( "ScenePhysicsProperties", this );
}


void BlenderSceneParts::Run()
{
	while(riScenesPad->hasData())
	{
		Pointer<BlenderScene> lScene = riScenesPad->getData(true);
		
		Pointer<ScenePhysicsProperties> lProps = new ScenePhysicsProperties();
		rPipeline->Emit(roPropsPad, lProps);
		
		Base *base = static_cast<Base*>(lScene->rScene->base.first);
		while (base)
		{
			::Object* ob = base->object;
	
			// Emmit as object
			Pointer<BlenderObject> lObject = new grn::BlenderObject();
			lObject->rObject = ob;
			rPipeline->Emit(roObjectsPad,lObject);
			
			base = base->next;
		}

	}

}
