
#include "BlenderSource.h"

#include "Pipeline.h"

#include "BKE_main.h"
#include "BKE_global.h"

/* This list includes only data type definitions */
#include "DNA_object_types.h"
#include "DNA_material_types.h"
#include "DNA_image_types.h"
#include "DNA_lamp_types.h"
#include "DNA_group_types.h"
#include "DNA_scene_types.h"
#include "DNA_camera_types.h"
#include "DNA_property_types.h"
#include "DNA_text_types.h"
#include "DNA_sensor_types.h"
#include "DNA_controller_types.h"
#include "DNA_actuator_types.h"
#include "DNA_mesh_types.h"
#include "DNA_meshdata_types.h"
#include "DNA_view3d_types.h"
#include "DNA_world_types.h"
#include "DNA_sound_types.h"
#include "DNA_key_types.h"
#include "DNA_armature_types.h"


using namespace grn;


IMPLEMENT_MODULE(BlenderSource);



BlenderSource::BlenderSource( Pipeline* aParent )
: Module(aParent)
{
	setSize(160,160);
	
	roScenesPad = new Module::tOutputPad<BlenderScene>( "BlenderScenes", this );
}


void BlenderSource::Init()
{
	for (Scene *sce= (Scene*)G.main->scene.first; sce; sce= (Scene*) sce->id.next)
	{
		// Wrap and emit scene
		Pointer<BlenderScene> lScene = new grn::BlenderScene();
		lScene->rScene= sce;
		rPipeline->Emit(roScenesPad,lScene);
	}

}

