
#include "SelectBlenderScene.h"

#include "Pipeline.h"


using namespace grn;


IMPLEMENT_MODULE(SelectBlenderScene);


SelectBlenderScene::SelectBlenderScene( Pipeline* aParent )
: Module(aParent)
{
	setSize(160,30);
	iX = 300;
	iY = 150;
	riScenes = new Module::tInputPad<grn::BlenderScene>( "InputScenes", this );
	roScene = new Module::tOutputPad<grn::BlenderScene>( "Selected", this );
	roOthers = new Module::tOutputPad<grn::BlenderScene>( "Others", this );
	strcpy(iName,"UnNamed");
}


void SelectBlenderScene::Run()
{
	while (riScenes->hasData())
	{
		Pointer<BlenderScene> lInObj = riScenes->getData(true);
		
		if ( std::string(lInObj->rScene->id.name)==std::string(iName))
			rPipeline->Emit(roScene,lInObj);
		else rPipeline->Emit(roOthers,lInObj);
	}
}


void SelectBlenderScene::Serialize( std::ostream& s ) const
{
	// Serialize parent first
	Module::Serialize(s);
	
	s << iName << std::endl;
}


void SelectBlenderScene::Deserialize( std::istream& s )
{
	// Deserialize parent first
	Module::Deserialize(s);

	s>>iName;
}

