#ifndef _GRN_MODULE_SELECTBLENDERSCENE_H_
#define _GRN_MODULE_SELECTBLENDERSCENE_H_

#include "Module.h"

#include "datatypes/BlenderTypes.h"
#include "datatypes/BasicTypes.h"
#include "datatypes/Object.h"

namespace grn
{
	
	class SelectBlenderScene
		: public Module
	{
		DECLARE_MODULE(SelectBlenderScene);
	
	protected:
	
		tInputPad<grn::BlenderScene>* riScenes;
		tOutputPad<grn::BlenderScene>* roScene;
		tOutputPad<grn::BlenderScene>* roOthers;
		
	public:
	
		SelectBlenderScene( Pipeline* aParent );

		virtual void Run();
		
		/** Output serializer.*/
		virtual void Serialize( std::ostream& s ) const;

		/** Input serializer.*/
		virtual void Deserialize( std::istream& s );

		// Buffer for blender UI edition of name
		char iName[80];
		
	};
		
}


#endif
