
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "BlenderEngine.h"

#include "girona/girona.h"
#include "girona/engine/Engine.h"
#include "girona/engine/GL2/RendererGL2.h"
#include "girona/RootPipeline.h"

#include <signal.h>

#include "SYS_System.h"

#include "mydevice.h"

	/***/

#include "DNA_view3d_types.h"
#include "DNA_screen_types.h"
#include "BKE_global.h"
#include "BIF_screen.h"
#include "BIF_scrarea.h"

#include "PIL_time.h"	

#include "BKE_main.h"	
#include "BLI_blenlib.h"
#include "BLO_readfile.h"
#include "DNA_scene_types.h"
	/***/

#include <vector>
#include <map>



extern "C" void StartGironaShell(struct ScrArea *area,
								 char* ,//scenename,
								 struct Main* ,//maggie,
								 int )//always_use_expand_framing)
{
	// Get the root pipeline
	grn::RootPipeline* lR = get_root_pipeline();

	// BUILD TEST 1/2
	//lR->Load("unnamed.girona");
	
	// Create the engine object
	grn::Renderer* lRenderer = new grn::RendererGL2();
	BlenderEngine* lEngine = new BlenderEngine(lR,lRenderer);

	// BUILD TEST 2/2
	// Load game data
	//lEngine->LoadData( "unnamed.data" );

	// Set up the game render pipeline
	lEngine->SetScreenArea( scrarea_get_win_x(area)
							 , scrarea_get_win_y(area)
							 , scrarea_get_win_width(area)
							 , scrarea_get_win_height(area) );

	
	lEngine->Start();
	
	// Time control
	double lLastTime = PIL_check_seconds_timer();

	// Main loop
	bool lExit = false;
	while (!lExit)
	{
		double lCurrentTime = PIL_check_seconds_timer();
		double lDeltaTime = lCurrentTime - lLastTime;
		lLastTime = lCurrentTime;
		
		// Tell the engine the delta time
		lEngine->SetDeltaTime(lDeltaTime);
		lEngine->SetCurrentTime(lCurrentTime);

		// Process events
		lExit = false;
		
		// Process event queue while there are events
		while ((qtest())&&(!lExit))
		{
			// Fetch event data
			short val; 
			unsigned short event = extern_qread(&val);
			
			// Test escape event
			if ( (event == ESCKEY) && (val != 0) ) 
			{
				lExit = true;
			}
			// Mouse interaction
			else if ((event == MOUSEX)||(event == MOUSEY))
			{
				/*
				short lOldMousePos[2];
				lOldMousePos[0] = iMousePos[0];
				lOldMousePos[1] = iMousePos[1];
				
				getmouseco_sc(iMousePos);
				for ( std::vector< MouseListener* >::iterator it = iMouseListeners.begin()
					; it!=iMouseListeners.end()
					; it++)
					(*it)->ProcessMouse( (iMousePos[0]-lOldMousePos[0]), (iMousePos[1]-lOldMousePos[1]) );
					*/
			}
			// Test other keys
			else lEngine->ProcessKey(lEngine->sBlenderKeyMap[event], val!=0 );
		
		}
		
		lEngine->RunFrame();
	}

	// Clear root data
	lR->ClearData();

	delete lEngine;
	delete lRenderer;

	// Done
}
